[CI] Need netpbm package on trusty
[survex.git] / buildmacosx.sh
blob66b631f9d72a7bd1ae49762caeef25c098f6fa55
1 #!/bin/sh
3 # You'll need some development tools which aren't installed by default. To
4 # get these you can install Xcode (which is a free download from Apple):
6 # https://developer.apple.com/xcode/downloads/
8 # To build, open a terminal (Terminal.app in the "Utils" folder in
9 # "Applications") and unpack the downloaded survex source code. E.g. for
10 # 1.2.17:
12 # tar xf survex-1.2.17.tar.gz
14 # Then change directory into the unpacked sources:
16 # cd survex-1.2.17
18 # And then run this script:
20 # ./buildmacosx.sh
22 # This will automatically download and temporarily install wxWidgets,
23 # PROJ.4 and FFmpeg in subdirectories of the source tree (this script is smart
24 # enough not to re-download or re-build these if it already has).
26 # If you already have wxWidgets, PROJ.4 and/or FFmpeg installed permanently,
27 # you can disable these by passing one or more extra options - e.g. to build
28 # none of them, use:
30 # ./buildmacosx.sh --no-install-wx --no-install-proj --no-install-ffmpeg
32 # If wxWidgets is installed somewhere such that wx-config isn't on your
33 # PATH you need to indicate where wx-config is by running this script
34 # something like this:
36 # env WX_CONFIG=/path/to/wx-config ./buildmacosx.sh
38 # (If you set WX_CONFIG, there's no need to pass --no-install-wx).
40 # If using a pre-installed wxWidgets, note that it must satisfy the
41 # following requirements:
43 # - It must be built with OpenGL support (--with-opengl).
45 # We strongly recommend using wxWidgets >= 3.0, but if you want to build with
46 # wxWidgets 2.8, it probably should be a "Unicode" build (--enable-unicode);
47 # wxWidgets >= 3.0 effectively is always a "Unicode" build, so the
48 # --enable-unicode option isn't needed (and is ignored if specified).
50 # This script builds diskimages which are known to work at least as far back
51 # as OS X 10.6.8. A build of wxWidgets 3.0.2 with the options we pass will
52 # default to assuming at least OS X 10.5, but we've not heard from anyone
53 # trying with such an old version.
55 # Mac OS X support "fat" binaries which contain code for more than one
56 # processor, but the wxWidgets build system doesn't seem to allow creating
57 # these, so we have to choose what processor family to build for. By default
58 # we build for the architecture of the version of OS X the build machine is
59 # running, which on a modern Mac will be x86_64, producing a build which will
60 # only work on 64-bit Intel Macs (but that's probably all machines modern
61 # enough to worry about).
63 # You can specify an arch explicitly on the command-line, e.g. to force a
64 # build for 64-bit Intel Macs:
66 # ./buildmacosx.sh x86_64
68 # Or if you want a build which also works on older 32 bit Intel Macs, then run
69 # this script passing i386 on the command line, like so (assuming your compiler
70 # supports this):
72 # ./buildmacosx.sh i386
74 # Or to build for much older machines with a Power PC processor, use (again
75 # assuming your compiler supports this):
77 # ./buildmacosx.sh ppc
79 set -e
81 install_wx=yes
82 install_proj=yes
83 install_ffmpeg=yes
84 while [ "$#" != 0 ] ; do
85 case $1 in
86 --no-install-wx)
87 install_wx=no
88 shift
90 --no-install-proj)
91 install_proj=no
92 shift
94 --no-install-ffmpeg)
95 install_ffmpeg=no
96 shift
98 --help|-h)
99 echo "Usage: $0 [--no-install-wx] [--no-install-proj] [--no-install-ffmpeg] [ppc|i386|x86_86]"
100 exit 0
103 echo "Unknown option - try --help" >&2
104 exit 1
107 break
109 esac
110 done
112 arch=$1
113 if [ -z "$arch" ] ; then
114 arch=`uname -m`
116 arch_flags="-arch $arch"
118 # UDBZ means the resultant disk image will only open on OS X 10.4 or above.
119 # UDZO works on 10.1 and later, but is larger, UDCO works on 10.0 as well,
120 # but is larger still.
121 dmg_format=UDBZ
123 WX_VERSION=3.0.3.1
124 WX_SHA256=f94d4d2713a7ba2778677e2c26c61ac8f6e4be711bde6f88747662d093d899bc
126 PROJ_VERSION=4.9.3
127 PROJ_SHA256=6984542fea333488de5c82eea58d699e4aff4b359200a9971537cd7e047185f7
129 FFMPEG_VERSION=3.1.3
130 FFMPEG_SHA256=f8575c071e2a64437aeb70c8c030b385cddbe0b5cde20c9b18a6def840128822
132 if [ -z "${WX_CONFIG+set}" ] && [ "$install_wx" != no ] ; then
133 if test -x WXINSTALL/bin/wx-config ; then
135 else
136 prefix=`pwd`/WXINSTALL
137 wxtarball=v$WX_VERSION.tar.gz
138 test -f "$wxtarball" || \
139 curl -L -O "https://github.com/wxWidgets/wxWidgets/archive/$wxtarball"
140 if echo "$WX_SHA256 $wxtarball" | shasum -a256 -c ; then
141 : # OK
142 else
143 echo "Checksum of downloaded file '$wxtarball' is incorrect, aborting."
144 exit 1
146 echo "+++ Extracting $wxtarball"
147 test -d "wxWidgets-$WX_VERSION" || tar xf "$wxtarball"
148 test -d "wxWidgets-$WX_VERSION/BUILD" || mkdir "wxWidgets-$WX_VERSION/BUILD"
149 cd "wxWidgets-$WX_VERSION/BUILD"
150 # Compilation of wx 3.0.2 fails on OS X 10.10.1 with webview enabled.
151 # A build with liblzma enabled doesn't work on OS X 10.6.8.
152 ../configure --disable-shared --prefix="$prefix" \
153 --with-opengl --enable-display \
154 --disable-webview --without-liblzma \
155 CC="gcc $arch_flags" CXX="g++ $arch_flags"
156 make -s
157 make -s install
158 cd ../..
160 WX_CONFIG=`pwd`/WXINSTALL/bin/wx-config
163 CC=`$WX_CONFIG --cc`
164 CXX=`$WX_CONFIG --cxx`
166 if [ "$install_proj" != no ] ; then
167 if test -f PROJINSTALL/include/proj_api.h ; then
169 else
170 prefix=`pwd`/PROJINSTALL
171 projtarball=proj-$PROJ_VERSION.tar.gz
172 test -f "$projtarball" || \
173 curl -O "http://download.osgeo.org/proj/$projtarball"
174 if echo "$PROJ_SHA256 $projtarball" | shasum -a256 -c ; then
175 : # OK
176 else
177 echo "Checksum of downloaded file '$projtarball' is incorrect, aborting."
178 exit 1
180 echo "+++ Extracting $projtarball"
181 test -d "proj-$PROJ_VERSION" || tar xf "$projtarball"
182 test -d "proj-$PROJ_VERSION/BUILD" || mkdir "proj-$PROJ_VERSION/BUILD"
183 cd "proj-$PROJ_VERSION/BUILD"
184 ../configure --disable-shared --prefix="$prefix" CC="$CC" CXX="$CXX"
185 make -s
186 make -s install
187 cd ../..
191 if [ "$install_ffmpeg" != no ] ; then
192 if test -f FFMPEGINSTALL/include/libavcodec/avcodec.h ; then
194 else
195 prefix=`pwd`/FFMPEGINSTALL
196 ffmpegtarball=ffmpeg-$FFMPEG_VERSION.tar.xz
197 test -f "$ffmpegtarball" || \
198 curl -O "https://ffmpeg.org/releases/$ffmpegtarball"
199 if echo "$FFMPEG_SHA256 $ffmpegtarball" | shasum -a256 -c ; then
200 : # OK
201 else
202 echo "Checksum of downloaded file '$ffmpegtarball' is incorrect, aborting."
203 exit 1
205 echo "+++ Extracting $ffmpegtarball"
206 test -d "ffmpeg-$FFMPEG_VERSION" || tar xf "$ffmpegtarball"
207 test -d "ffmpeg-$FFMPEG_VERSION/BUILD" || mkdir "ffmpeg-$FFMPEG_VERSION/BUILD"
208 cd "ffmpeg-$FFMPEG_VERSION/BUILD"
209 FFMPEG_CONFIGURE_OPTS='--disable-shared --disable-programs --disable-network --disable-bsfs --disable-protocols --disable-devices'
210 # We don't need to decode video, but disabling these causes a link failure
211 # when linking aven:
212 # --disable-decoders --disable-demuxers
213 if ! nasm -hf|grep -q macho64 ; then
214 # nasm needs to support macho64, at least for x86_64 builds.
215 FFMPEG_CONFIGURE_OPTS="$FFMPEG_CONFIGURE_OPTS --disable-yasm"
217 ../configure --prefix="$prefix" --cc="$CC" $FFMPEG_CONFIGURE_OPTS
218 make -s
219 make -s install
220 cd ../..
224 test -n "$WX_CONFIG" || WX_CONFIG=`which wx-config`
225 if test -z "$WX_CONFIG" ; then
226 echo "WX_CONFIG not set and wx-config not on your PATH"
227 exit 1
229 # Force static linking so the user doesn't need to install wxWidgets.
230 WX_CONFIG=$WX_CONFIG' --static'
231 rm -rf *.dmg Survex macosxtmp
232 C=`pwd`
233 D=$C/Survex
234 T=$C/macosxtmp
235 PKG_CONFIG_PATH=$C/PROJINSTALL/lib/pkgconfig:$C/FFMPEGINSTALL/lib/pkgconfig
236 export PKG_CONFIG_PATH
237 ./configure --prefix="$D" --bindir="$D" --mandir="$T" \
238 WX_CONFIG="$WX_CONFIG" CC="$CC" CXX="$CXX"
239 make
240 make install
241 #mv Survex/survex Survex/Survex
243 # Construct the Aven application bundle.
244 mkdir -p Survex/Aven.app/Contents/MacOS Survex/Aven.app/Contents/Resources
245 cp lib/Info.plist Survex/Aven.app/Contents
246 printf APPLAVEN > Survex/Aven.app/Contents/PkgInfo
247 mv Survex/share/doc/survex Survex/Docs
248 rmdir Survex/share/doc
249 mv Survex/share/survex/images Survex/Aven.app/Contents/Resources/
250 mv Survex/share/survex/unifont.pixelfont Survex/Aven.app/Contents/Resources/
251 ln Survex/share/survex/*.msg Survex/Aven.app/Contents/Resources/
252 mv Survex/aven Survex/Aven.app/Contents/MacOS/
253 ln Survex/cavern Survex/extend Survex/Aven.app/Contents/MacOS/
254 rm -rf Survex/share/applications Survex/share/icons Survex/share/mime-info
255 mkdir Survex/share/survex/proj
256 cp -p PROJINSTALL/share/proj/epsg PROJINSTALL/share/proj/esri Survex/share/survex/proj
257 mkdir Survex/Aven.app/Contents/Resources/proj
258 ln Survex/share/survex/proj/* Survex/Aven.app/Contents/Resources/proj
260 # Create .icns files in the bundle's "Resources" directory.
261 for zip in lib/icons/*.iconset.zip ; do
262 unzip -d Survex/Aven.app/Contents/Resources "$zip"
263 i=`echo "$zip"|sed 's!.*/\(.*\)\.zip$!\1!'`
264 iconutil --convert icns "Survex/Aven.app/Contents/Resources/$i"
265 rm -rf "Survex/Aven.app/Contents/Resources/$i"
266 done
268 size=`du -s Survex|sed 's/[^0-9].*//'`
269 # Allow 1500 extra sectors for various overheads (1000 wasn't enough).
270 sectors=`expr 1500 + "$size"`
271 # Partition needs to be at least 4M and sectors are 512 bytes.
272 if test "$sectors" -lt 8192 ; then
273 sectors=8192
275 echo "Creating new blank image survex-macosx.dmg of $sectors sectors"
276 # This creates the diskimage file and initialises it as an HFS+ volume.
277 hdiutil create -sectors "$sectors" survex-macosx -layout NONE -fs HFS+ -volname Survex
279 echo "Presenting image to the filesystems for mounting."
280 # This will mount the image onto the Desktop.
281 # Get the name of the device it is mounted on and the mount point.
283 # man hdiutil says:
284 # "The output of [hdiutil] attach has been stable since OS X 10.0 (though it
285 # was called hdid(8) then) and is intended to be program-readable. It consists
286 # of the /dev node, a tab, a content hint (if applicable), another tab, and a
287 # mount point (if any filesystems were mounted)."
289 # In reality, it seems there are also some spaces before each tab character.
290 hdid_output=`hdid survex-macosx.dmg|tail -1`
291 echo "Last line of hdid output was: $hdid_output"
292 dev=`echo "$hdid_output"|sed 's!/dev/\([^ ]*\).*!\1!'`
293 mount_point=`echo "$hdid_output"|sed 's!.* !!'`
295 echo "Device $dev mounted on $mount_point, copying files into image."
296 ditto -rsrcFork Survex "$mount_point/Survex"
297 ditto lib/INSTALL.OSX "$mount_point/INSTALL"
299 echo "Detaching image."
300 hdiutil detach "$dev"
302 version=`sed 's/^VERSION *= *//p;d' Makefile`
303 file=survex-macosx-$version.dmg
304 echo "Compressing image file survex-macosx.dmg to $file"
305 hdiutil convert survex-macosx.dmg -format "$dmg_format" -o "$file"
306 rm survex-macosx.dmg
308 echo "$file created successfully."